<template>
  <div class="article section">
    <div class="article-info">
      <div class="article-poster">
        <img :src="exercise.image" />
        <div class="article-poster__name">
          <!-- <i class="bx bx-heart"></i>
            <p>Добавить <b> в избранное </b></p> -->
          <p>{{ exercise.title }}</p>
        </div>
      </div>
      <div class="article-teacher">
        <img :src="exercise.teacher_avatar" />
        <div class="article-teacher__name">
          <p>Муаллифи мақола:</p>
          <p>{{ exercise.teacher_name }}</p>
          <p style="margin-top: 5px;">{{ exercise.teacher_name }}</p>
          <p style="margin-top: 5px;">
            <a :href="'tel:' + exercise.teacher_phone">
              {{ exercise.teacher_phone }}
            </a>
          </p>
        </div>
      </div>
    </div>
    <div>
      <div class="article-content">
        <div class="article-breadcrumb">
          <nuxt-link to="/catalog/events"> Чорабиниҳо </nuxt-link>
          <i class="bx bx-chevron-right"></i>
          <p>{{ exercise.title }}</p>
        </div>
        <h1 class="article-content__title">
          {{ exercise.title }}
        </h1>
        <div v-html="exercise.desc" class="article-content__text"></div>
      </div>
      <template v-if="$auth.loggedIn">
        <template v-if="assignment.completed == 'waiting'">
          <template
            v-if="
              have_access == false &&
              $auth.user.specialization !== 'Маъмур' &&
              $auth.user.specialization !== 'Омӯзгор'
            "
          >
            <div class="article-content__footer" v-if="send_apply == false">
              <button
                type="button"
                class="curve-btn"
                @click="apply()"
                v-if="
                  $auth.loggedIn &&
                  $auth.user.specialization !== 'Маъмур' &&
                  $auth.user.specialization !== 'Омӯзгор'
                "
              >
                <div>Дархост пешниҳод намудан</div>
              </button>
              <i class="bx bx-calendar-exclamation"></i>
              <div class="article-content__footer-text">
                Шумо бояд барои дастрасӣ ба ин курс <br />
                <b>дархост гузоред</b>
              </div>
            </div>
            <div v-else class="article-content__footer">
              <i class="bx bx-calendar-exclamation"></i>
              <div class="article-content__footer-text">
                Дархост фиристода шуд, <br />
                <b>лутфан ҷавобро интизор шавед</b>
              </div>
            </div>
          </template>
          <form @submit.prevent="complete()" v-else>
            <div class="article-reports" v-if="assignment.canceled">
              <b>
                Шуморо барои қабул шудан дар фаъолият рад карданд, паём аз
                муаллифи мақола:
              </b>
              — {{ assignment.message }}
            </div>
            <div class="article-materials" v-if="exercise.materials.length > 0">
              <b> Маводҳои истифодашаванда (истинод): </b>
              <ul>
                <li v-for="(material, id) in exercise.materials" :key="id">
                  {{ id + 1 }}.
                  <a :href="material" target="_blank">
                    {{ material.replace("/exercises/materials/", "") }}
                  </a>
                </li>
              </ul>
            </div>
            <!-- <div class="article-reports">
              <b>Шакли ҳисоботӣ барои гирифтани соатҳои кредитӣ</b>
              — {{ exercise.reports }}
              <input
                type="file"
                accept=".pdf,.word,.doc,.docx"
                @change="inputReports"
                ref="fileInput"
                class="upload-input"
                required
              />
              <button
                type="button"
                class="form-btn"
                @click="$refs.fileInput.click()"
              >
                Иловаи ҳуҷҷат
              </button>
              <div
                class="article-reports__name"
                v-for="(report, index) in reports_blob"
                :key="index"
              >
                <a :href="report.url" target="_blank">
                  <b> {{ index + 1 }}.</b> {{ report.name }}
                </a>
                <button type="button" @click="removeReports(report)">
                  Тоза кунед
                </button>
              </div>
            </div> -->
            <template v-if="!assignment.canceled">
              <div class="article-test" v-if="exercise_test.length > 0">
                <b>Санҷишро гузаред:</b>
                <div
                  v-for="(test, test_id) in exercise.test"
                  :key="test_id"
                  class="article-test__wrapper"
                >
                  {{ test.question }}
                  <div class="article-test__answers">
                    <ul
                      v-for="(answer, answer_id) in test.answers"
                      :key="answer_id"
                    >
                      <li>
                        <input
                          type="radio"
                          :id="answer.text + answer_id + test_id"
                          :name="answer + test_id"
                          :value="answer.text"
                          required
                          v-model="exercise_test[test_id].answer"
                        />
                        <label :for="answer.text + answer_id + test_id">
                          {{ answer.text }}
                        </label>
                      </li>
                    </ul>
                  </div>
                </div>
              </div>
            </template>
            <div v-else class="article-test">
              <b>Шумо аз имтиҳон бо {{ assignment.grade }} хол гузаштед</b>
            </div>

            <div class="article-credits">
              <b>Шумораи соатҳои кредитие, ки шумо мегиред:</b>
              — {{ exercise.credit }}
            </div>
            <button
              class="curve-btn"
              type="submit"
              v-if="
                $auth.user.specialization !== 'Маъмур' &&
                $auth.user.specialization !== 'Омӯзгор'
              "
            >
              <div>Супоришро иҷро намоед</div>
            </button>
          </form>
        </template>
        <template v-if="assignment.completed == 'pending'">
          <div class="article-content__footer">
            <i class="bx bx-calendar-exclamation"></i>
            <div class="article-content__footer-text">
              Дар ҳуҷраи инфиродӣ посухро интизор шавед <br />
              <b>тасдиқи муаллифи макола зарур аст</b>
            </div>
          </div>
        </template>
        <template v-if="assignment.completed == 'done'">
          <div class="article-content__footer">
            <i class="bx bx-calendar-exclamation"></i>
            <div class="article-content__footer-text">
              Шумо аллакай аз иҷрои супориш гузаштед, <br />
              <b>
                дафтарчаи бақайдгирии соатҳои кредитиро дар ҳуҷраи инфиродӣ
                санҷед
              </b>
            </div>
          </div>
        </template>
      </template>
      <template v-else>
        <div class="article-content__footer">
          <login v-if="!$auth.loggedIn">
            <button type="button" class="curve-btn">
              <div>Дархост пешниҳод намудан</div>
            </button>
          </login>
          <i class="bx bx-calendar-exclamation"></i>
          <div class="article-content__footer-text">
            Шумо бояд барои дастрасӣ ба ин курс <br />
            <b>дархост гузоред.</b>
          </div>
        </div>
      </template>
    </div>

    <div class="article-footer" v-if="banner.img">
      <a :href="banner.link" target="_blank">
        <img :src="banner.img" alt="" class="article-footer__banner" />
      </a>
    </div>
  </div>
</template>

<script>
export default {
  data() {
    return {
      have_access: false,
      send_apply: false,
      assignment: {
        completed: "waiting",
        canceled: null,
        message: null,
        grade: null,
      },
      status_completed: "waiting",
      exercise_id: null,
      exercise: {},
      exercise_test: [],
      reports_blob: [],

      form: {
        user_id: null,
        exercise_id: null,
        teacher_id: null,
        // reports: [],
        grade: null,
        recreate: false,
        assignment_id: null,
        credit: null,
      },

      banner: {
        img: null,
        link: null,
      },
    };
  },
  fetchOnServer: false,
  fetch() {
    this.getExercises();
    this.getBanner();
  },
  watch: {
    "$auth.user"(n) {
      console.log(n);
      this.checkUserPermissions();
    },
  },
  methods: {
    checkUserPermissions() {
      if (this.$auth.user) {
        const user_exercises = this.$auth.user.exercises;
        if (user_exercises.length > 0) {
          for (const item of user_exercises) {
            if (item.exercise_id === this.$route.params.id) {
              this.send_apply = true;
            }
          }
        }
        this.exercise.applications.forEach((element) => {
          if (element.id === this.$auth.user._id) {
            if (element.access) {
              this.have_access = true;
            }
          }
        });
      }
    },

    getExercises() {
      let access = true;
      if (this.$route.query.access) {
        access = this.$route.query.access;
      }
      this.$axios
        .$post("/exercise/getExercises", {
          _id: this.$route.params.id,
          access,
          user_id: this.$auth.user ? this.$auth.user._id : "",
        })
        .then(({ exercises, assignmnet }) => {
          if (assignmnet) {
            this.assignment = assignmnet;
          }
          if (exercises.length > 0 && this.$auth.user) {
            this.exercise = exercises[0];
            this.exercise_id = this.exercise._id;
            this.checkUserPermissions();
            this.exercise.test.forEach((test) => {
              test.answers.sort(() => Math.round(Math.random() * 100) - 50);
              this.exercise_test.push({
                question: test.question,
                answer: "",
              });
            });
            this.form.user_id = this.$auth.user._id;
            this.form.exercise_id = this.$route.params.id;
            this.form.teacher_id = this.exercise.teacher_id;
            this.form.reports = [];
            this.form.grade = null;
          } else {
            this.$router.push("/");
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },

    apply() {
      this.$axios
        .$post("/exercise/apply", {
          exercise_id: this.exercise_id,
          user: {
            id: this.$auth.user._id,
            name: this.$auth.user.name,
            phone: this.$auth.user.phone,
            region: this.$auth.user.region,
            workplace: this.$auth.user.workplace,
            specialization: this.$auth.user.specialization,
            access: false,
          },
        })
        .then(() => {
          alert("Мунтазир бошед, то дархости шумо қабул гардад!");
          this.send_apply = true;
        })
        .catch((error) => {
          console.log(error);
        });
    },

    complete() {
      if (this.checkTest()) {
        // this.uploadReports()
        //   .then(() => {
            this.$axios
              .$post("/assignments/addAssigment", this.form)
              .then(() => {
                this.assignment.completed = "pending";
              })
              .catch((error) => {
                console.log(error);
              });
          // })
          // .catch((err) => console.log(err));
      }
    },

    checkTest() {
      if (this.assignment.canceled) {
        this.form.recreate = true;
        this.form.assignment_id = this.assignment.assignment_id;
        return true;
      } else {
        let correct_answers = 0;
        this.exercise.test.forEach((teacher_test) => {
          teacher_test.answers.forEach((teacher_answer) => {
            this.exercise_test.forEach((user_test) => {
              if (teacher_answer.correct) {
                if (user_test.answer == teacher_answer.text) {
                  correct_answers += 1;
                }
              }
            });
          });
        });
        const grade = (correct_answers / this.exercise.test.length) * 100;
        if (grade >= 70) {
          this.form.grade = grade;
          return true;
        } else {
          alert("Шумо барои иҷрои супориш дар санҷиш холҳои кофӣ нагирифтед");
          return false;
        }
      }
    },

    // async uploadReports() {
    //   const formData = new FormData();
    //   this.reports_blob.forEach((el) => {
    //     formData.append(
    //       "reports",
    //       el.file,
    //       this.$auth.user.name + "-" + el.name
    //     );
    //   });
    //   const url = this.$config.UPLOADS_BACKEND_URL + "/uploadReports";
    //   try {
    //     await this.$axios.$post(url, formData, {
    //       headers: {
    //         "content-type": "multipart/form-data",
    //       },
    //     });
    //   } catch (err) {
    //     throw new Error("uploadReports error", err.response);
    //   }
    // },

    // async inputReports(e) {
    //   if (this.form.reports.length == 10) {
    //     alert("Шумораи ҳуҷҷатҳо набояд аз 10 адад зиёд бошанд");
    //   } else {
    //     const report = e.target.files[0];
    //     if (report === undefined) {
    //       return;
    //     }
    //     if (report.size > 524288 * 6) {
    //       alert("Андозаи ҳуҷҷат набояд аз 3 мегабайт зиёд бошад");
    //     } else {
    //       const blob = new Blob(e.target.files, {
    //         type: report.type,
    //       });
    //       const url = window.URL.createObjectURL(blob);
    //       this.form.reports.push(
    //         "/assignments/reports/" + this.$auth.user.name + "-" + report.name
    //       );
    //       this.reports_blob.push({
    //         name: report.name,
    //         url: url,
    //         file: report,
    //       });
    //     }
    //   }
    // },

    // removeReports(report) {
    //   this.$refs.fileInput.value = "";
    //   this.reports_blob = this.reports_blob.filter(
    //     (el) => el.name !== report.name
    //   );
    //   this.form.reports = this.form.reports.filter(
    //     (el) => el.name !== report.name
    //   );
    // },

    getBanner() {
      this.$axios
        .$get("/settings/getBanner")
        .then((response) => {
          if (response.length > 0) {
            this.banner.img = response[0].img;
            this.banner.link = response[0].link;
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },
  },
};
</script>

<style lang="scss" scoped>
.article {
  margin-top: 40px;
  display: grid;
  grid-template-columns: 0.71fr 2fr 0.7fr;
  text-align: left;
  grid-gap: 20px;
  color: #07003a;
  position: relative;
  @include less-than(tablet) {
    grid-template-columns: repeat(1, 1fr);
    grid-gap: 10px;
  }

  &-info {
    // position: sticky;
    // top: 80px;
    display: flex;
    flex-direction: column;
    height: fit-content;
    // @include less-than(tablet) {
    //   position: relative;
    //   top: 0;
    // }
  }
  &-poster {
    background: #fff;
    box-shadow: 0 0 35px rgb(0 0 0 / 10%);
    img {
      max-height: 250px;
      width: 100%;
      object-fit: cover;
      @include less-than(tablet) {
        max-height: 100px;
      }
    }
  }
  &-poster__name {
    display: flex;
    padding: 16px 10px;
    width: 100%;
    justify-content: center;
    align-items: center;
    // cursor: pointer;
    transition: all ease 0.3s;
    // &:hover {
    //   color: #0c63e4;
    // }
    i {
      font-size: 30px;
      margin-right: 10px;
    }
    p {
      font-size: 14px;
      b {
        font-family: "Montserrat-Bold";
      }
    }
  }

  &-content {
    min-height: 70vh;
    padding: 20px;
    background-color: #fff;
    box-shadow: 1px 1.732px 10px 0 rgb(0 0 0 / 5%);
    @include less-than(tablet) {
      margin-left: 0px;
    }
  }
  &-content__title {
    line-height: 1.3;
    font-size: 26px;
    font-family: "Montserrat-Bold";
  }
  &-breadcrumb {
    display: flex;
    flex-wrap: wrap;
    font-size: 13px;
    margin-bottom: 20px;
    a {
      border-bottom: 1px solid rgba(0, 0, 0, 0.15);
      font-weight: 300;
      color: #8b929f;
      transition: all ease 0.3s;
      &:hover {
        color: #0c63e4;
        border-color: #0c63e4;
      }
    }
    p {
    }
    i {
      color: #8b929f;
      padding: 0 10px;
    }
  }

  &-content__footer {
    display: flex;
    align-items: center;
    justify-content: center;
    margin-top: 40px;
    i {
      font-size: 30px;
      margin-left: 40px;
    }
  }
  &-content__footer-text {
    margin-left: 10px;
    font-size: 12px;
    b {
    }
  }

  &-footer {
    position: sticky;
    top: 80px;
    height: fit-content;
    img {
      width: 100%;
      max-height: 500px;
    }
  }

  &-teacher {
    display: flex;
    height: fit-content;
    flex-direction: column;
    justify-content: center;
    align-items: center;
    margin: 20px 0;
    background-color: #fff;
    padding: 20px;
    box-shadow: 0 0 35px rgb(0 0 0 / 10%);
    img {
      object-fit: cover;
      width: 100px;
      height: 100px;
      border: 1px solid #ccc;
    }
    @include less-than(tablet) {
      position: relative;
      top: 0;
      flex-direction: row;
      margin-bottom: 10px;
      img {
        width: 80px;
        height: 80px;
      }
    }
  }
  &-teacher__name {
    display: flex;
    padding: 16px 10px;
    width: 100%;
    justify-content: center;
    align-items: center;
    flex-direction: column;
    transition: all ease 0.3s;
    p {
      font-size: 14px;
      b {
        font-family: "Montserrat-Bold";
      }
    }
  }

  &-materials,
  &-reports,
  &-test,
  &-credits {
    margin: 20px 0;
    padding: 20px;
    background-color: #fff;
    box-shadow: 1px 1.732px 10px 0 rgb(0 0 0 / 5%);
    li {
      list-style: none;
      margin: 0;
      padding: 0;
    }
    b {
      display: block;
      font-size: 18px;
      margin-bottom: 10px;
    }
  }

  &-materials {
    li {
      margin-top: 10px;
      a:hover {
        color: #0c63e4;
      }
    }
  }

  &-reports {
    margin: 20px 0;
    .form-btn {
      margin-top: 10px;
    }
  }
  &-reports__name {
    margin-top: 20px;
    margin-left: 20px;
    b {
      display: inline;
    }
    a:hover {
      color: #0c63e4;
    }
    button {
      border-radius: 10px;
      padding: 5px 10px;
      border: 1px solid #ccc;
      margin-left: 20px;
      background: none;
      &:hover {
        color: #0c63e4;
      }
    }
  }

  &-test__wrapper {
    border: 1px solid #e1e1e6;
    border-radius: 12px;
    padding: 20px;
    margin-bottom: 20px;
    &:nth-last-child(1) {
      margin-bottom: 0px;
    }
  }
  &-test__answers {
    margin-top: 10px;
    li {
      display: flex;
      margin-bottom: 10px;
    }
    label,
    input {
      display: block;
      padding: 5px 0;
      cursor: pointer;
      &:hover {
        color: #0c63e4;
      }
    }
    label {
      padding-left: 10px;
      padding-right: 10px;
    }
  }
}
</style>
